package io.gitlab.jfronny.muscript.ast.literal;

import io.gitlab.jfronny.muscript.compiler.ExprWriter;
import io.gitlab.jfronny.muscript.compiler.Order;
import io.gitlab.jfronny.muscript.data.Scope;
import io.gitlab.jfronny.muscript.ast.BoolExpr;

import java.io.IOException;

public final class BoolLiteral extends BoolExpr {
    public final boolean value;

    public BoolLiteral(int chStart, int chEnd, boolean value) {
        super(Order.Primary, chStart, chEnd);
        this.value = value;
    }

    @Override
    public Boolean get(Scope dataRoot) {
        return value;
    }

    @Override
    public BoolExpr optimize() {
        return this;
    }

    @Override
    public void decompile(ExprWriter writer) throws IOException {
        writer.append(value ? "true" : "false");
    }

    @Override
    public boolean equals(Object obj) {
        return obj instanceof BoolLiteral literal && value == literal.value;
    }
}
